
anim8 = require 'anim8'
require("middleclass")
Jumper = require 'Jumper'
require("pathfinder")
require("tostring")

--****** ATL ******--  
	loader = require("AdvTiledLoader/Loader")
	loader.path = "maps/" --Change this to wherever your .tmx files are
	map = loader.load("map1.tmx") --Change this to the name of your mapfile
	map.useSpriteBatch = true
	playerLayer = map:newCustomLayer("playerLayer", map:layerPosition("Player"))
	map.drawObjects = false
--*****************--
	
	player = {}

function love.load()
--	love.graphics.setMode(1280, 720, false, true, 4)
		

	
	winh = love.graphics.getHeight( )
	winw = love.graphics.getWidth( )
  
	worldmap = {
	tx = 0,
	ty = 0,
	xscroll = winw*0.3,
	yscroll = winh*0.3,
	scale = 1 , 
	}
	ftx, fty = 0
			
	TLbind,control = love.filesystem.load("TLbind.lua")()
	TLbind.keys = {
    w="sup", a="sleft", s="sdown", d="sright", [" "]="jump", lctrl="attack", escape="menu",
    up="up", left="left", down="down", right="right", z="jump", rctrl="attack",}
	

--****** Jumper ******--
	path, cost = nil
	
	wmap = walkmap(map.width, map.height, "Collision")
	
	walkable = 0
	allowDiagonal = true
	smoothpath = false
	drawpath = false
	pather = Jumper(wmap,walkable,allowDiagonal)

	
--******  Player ******--

--	image = love.graphics.newImage('13sprite.png')
	player.x = 400
	player.y = 300
	player.scale = 1
	princess1 = love.graphics.newImage('princess1.png')
	princess2 = love.graphics.newImage('princess2.png')
	player.image = princess2

	playerAnim = anim8.newGrid(64, 64, player.image:getWidth(), player.image:getHeight())

player["up"] = anim8.newAnimation('loop', playerAnim('1-9,1'), 0.1)
player["left"] = anim8.newAnimation('loop', playerAnim('1-9,2'), 0.1)
player["down"] = anim8.newAnimation('loop', playerAnim('1-9,3'), 0.1)
player["right"] = anim8.newAnimation('loop', playerAnim('1-9,4'), 0.1)
 

	
	player.speed = 300

	player.move = require 'Object_move'
	player.move:setPos(player.x, player.y)

	
end

function checkSensor(layer)

	for i, obj in pairs( map(layer).objects ) do
		if col(player.x-16, player.y-16, obj) then
			if obj.name == "1" then
				player.image = princess1
			end
				
			if obj.name == "2" then
				player.image = princess2
			end
			
			if obj.name == "3" then
				player.speed = 900
			end
			
			if obj.name == "4" then
				player.speed = 300
			end
	
		end
	end
end

 
function col(x, y, o)
	return x < o.x + o.width and x > o.x and y < o.y + o.width and y > o.y
end
 
function playerLayer:draw()

	
	player[player.move:dir()]:draw(player.image,player.x,player.y,0,player.scale,player.scale,64-16,64+8)
end

function playerLayer:update(dt)

end

function love.update(dt)
	player.x, player.y = player.move:getPos()

	sx = player.x + worldmap.tx
	sy = player.y + worldmap.ty
	TLbind:update()
  	player[player.move:dir()]:update(dt)

	if control.sup then worldmap.ty = worldmap.ty + player.speed*dt end
	if control.sdown then worldmap.ty = worldmap.ty - player.speed*dt end
	if control.sleft then worldmap.tx = worldmap.tx + player.speed*dt end
	if control.sright then worldmap.tx = worldmap.tx - player.speed*dt end
  
	-- scroll when near screen border
		if sy < worldmap.yscroll  then
			if worldmap.ty < 0 then
				worldmap.ty = worldmap.ty + player.speed*dt
			else
				worldmap.ty = 0
			end
		end

		if sy > winh-worldmap.yscroll then
			if -worldmap.ty < ((map.tileHeight * map.height)-winh) then
				worldmap.ty = worldmap.ty - player.speed*dt
			else
				worldmap.ty = -((map.tileHeight * map.height)-winh)
			end
		end

		if sx < worldmap.xscroll then
			if worldmap.tx < 0 then		
				worldmap.tx = worldmap.tx + player.speed*dt
			else
				worldmap.tx = 0
			end
		end

		if sx > winw - worldmap.xscroll then
			if -worldmap.tx < ((map.width * map.tileWidth)-winw) then	
				worldmap.tx = worldmap.tx - player.speed*dt
			else
				worldmap.tx = -((map.width * map.tileWidth)-winw)
			end
		end
movePath(dt, player.move, player.speed)

end



--********************************************************************************--
function love.draw()
	prnty = 0
	ftx, fty = math.floor(worldmap.tx), math.floor(worldmap.ty)

	love.graphics.push()
		love.graphics.translate(ftx, fty)
		love.graphics.scale(1/worldmap.scale)
		map:draw()
		map:autoDrawRange(ftx, fty, 1/worldmap.scale, 64/worldmap.scale)
		if drawpath then
			drawPath()
		end

		checkSensor("Sensor")
		
	love.graphics.pop()
	
	pr("fps = " .. love.timer.getFPS( ))
	
	if allowDiagonal then
		pr("(z) allowDiagonal = true")
	else
		pr("(z) allowDiagonal = false")
	end
	
	if smoothpath then
		pr("(x) smoothpath = true")
	else
		pr("(x) smoothpath = false")
	end
		
	if drawpath then
		pr("(c) drawpath = true")
	else
		pr("(c) drawpath = false")
	end
		
	if path then
		pr("Cost = " .. cost)
	end

		
end
--********************************************************************************--

function pr(var)
	prnty = prnty + 10
	love.graphics.print( var, 10, prnty)
end


function love.mousepressed(x,y,button)
	
	if button == 'l' then
		if not path then
			startx, starty = player.move:getPos()
			makepath(startx, starty, (x-ftx)*worldmap.scale, (y-fty)*worldmap.scale, allowDiagonal, smoothpath)
		end
	elseif button =='r' then

	end
end

function love.keypressed(k)
	if k == "z" then
		allowDiagonal = switch(allowDiagonal)
	elseif k == "x" then
		smoothpath = switch(smoothpath)
	elseif k == "c" then
		drawpath = switch(drawpath)
	end
end


function switch(test)
	if test then return false end
	if not test then return true end
end
